enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) `0x2007 .`
void printd ( char d ) `0x0F & # 10 < { '0' ~ '7' } + printc`
void printb ( char b ) `# 4 >> printd printd`
void printn ( int n ) `# 8 >> printb printb`
void prints ( char * s ) `# , ( # , printc 1 + # , ) _`

int va_count ( ) ;
int va_arg ( int n ) ;

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

void printf ( char * fmt , ... ) {
   char * p = fmt ;
   int n = 0 ;
   char c ;
   while ( c = * p ++ ) {
      if ( c == '%' ) {
         switch ( c = * p ++ ) {
            case 'c' : printc ( va_arg ( n ++ ) ) ; break ;
            case 'X' : printn ( va_arg ( n ++ ) ) ; break ;
            case 's' : prints ( va_arg ( n ++ ) ) ; break ;
            default  : printc ( c ) ;
         }
      }
      else printc ( c ) ;
   }
}

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;

   printf ( "%c%X, %s%c" , 'H' , 0xE110 , "WORLD" , '!' ) ;

   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}
