enum {
   PPUCTRL1  = 0x2000 ,
   PPUCTRL2  = 0x2001 ,
   VRAMADDR1 = 0x2005 ,
   VRAMADDR2 = 0x2006 ,
   VRAM      = 0x2007
} ;

void printc ( char c ) {
   * ( char * ) VRAM = c ;
}

void VRAMADDR ( int n ) {
   * ( char * ) VRAMADDR2 = n >> 8 ;
   * ( char * ) VRAMADDR2 = n ;
   * ( char * ) VRAMADDR1 = 0x00 ;
   * ( char * ) VRAMADDR1 = 0x00 ;
}

void VRAMDATA ( ... ) `# [ # 2 + ? 0x2007 . ] [ nip ]`

void palette ( ) {
   VRAMADDR ( 0x3F00 ) ;
   VRAMDATA ( 0x0F , 0x30 , 0x0F , 0x0F ) ;
}

void f ( int n ) {
   switch ( n ) {
      case 1 : printc ( '1' ) ; break ;
      case 2 : printc ( '2' ) ; break ;
      case 10 : printc ( 'A' ) ; break ;
      default : printc ( '.' ) ;
   }
}

int i ;

void main ( ) {
   * ( char * ) PPUCTRL1 = 0 ;
   * ( char * ) PPUCTRL2 = 0 ;
   palette ( ) ;
   VRAMADDR ( 0x2040 ) ;

   for ( i = 0 ; i < 16 ; i ++ ) f ( i ) ;

   * ( char * ) PPUCTRL1 = 0b10000000 ;
   * ( char * ) PPUCTRL2 = 0b00011110 ;
   while ( 1 ) ;
}
